#include "smtp.h"

extern smtpi jtin;

pthread_mutex_t vip_mutex = PTHREAD_MUTEX_INITIALIZER;

xmlnode smtp_vip_createnode(pool p,char *lcVIP,char *lcJID)
   {
   xmlnode loRPC,loQuery,loMC;
   loRPC=xmlnode_new_tag_pool(p,"iq");

   xmlnode_put_attrib(loRPC,"to",lcVIP);
   xmlnode_put_attrib(loRPC,"from",jtin->met);
   xmlnode_put_attrib(loRPC,"type","set");
   xmlnode_put_attrib(loRPC,"id",spools(p,"viprpc-",lcJID,p));

   xmlnode_put_attrib(loQuery=xmlnode_insert_tag(loRPC,"query"),"xmlns",NS_IQ_RPC);

   loMC=xmlnode_insert_tag(loQuery,"methodCall");
   xmlnode_insert_cdata(xmlnode_insert_tag(loMC,"methodName"),"isVIP",-1);
   loMC=xmlnode_insert_tag(loMC,"params");
   loMC=xmlnode_insert_tag(loMC,"param");
   loMC=xmlnode_insert_tag(loMC,"value");
   xmlnode_insert_cdata(xmlnode_insert_tag(loMC,"string"),lcJID,-1);
   return loRPC;
   }

void smtp_vip_mtq(void *arg)
   {

   smtp_tu par_o= (smtp_tu) arg;
   char *lcVIP,*lcJID;
   xmlnode loJID,loRPC,loFile,loQuery,loMC,loGroup;
   int liCount;
   pool p=par_o->p;

__HHUNG
   if ((lcVIP=xmlnode_get_tag_data(jtin->config,"core/vip"))==NULL)
      {
__HHUNG      pool_free(p);
__HHUNG      return;
      }

__HHUNG
   if (pthread_mutex_trylock(&vip_mutex)==EBUSY)
      {
__HHUNG      pool_free(p);
__HHUNG      return;
      }
__HHUNG
   if (jtin->tmpVIP!= (xmlnode) NULL)
      {
__HHUNG      xmlnode_free(jtin->tmpVIP);
      }

__HHUNG   jtin->tmpVIP=xmlnode_new_tag("tmpVIP");
__HHUNG   smtp_PoolsReg(3030, xmlnode_pool(jtin->tmpVIP));

   if ((jtin->iLogDebug&2)==2)
__HHUNG   log_notice(SMTP_ZONE,"VIP module - START");
   for (loFile = xmlnode_get_tag(jtin->roster_files,"file"); loFile != NULL; loFile = xmlnode_get_nextsibling(loFile))
       {
       if (loFile->type!=NTYPE_TAG)
          continue;


/*
<iq type='set' 
    from='gorila@jabber.cz/Psi' 
    to='rpc@jabbim.cz/service' 
    id='rpc1'>
<query xmlns='jabber:iq:rpc'>
<methodCall>
<methodName>isVIP</methodName>
<params>
<param>
<value><string>jjk@jabbim.cz</string></value>
</param>
</params>
</methodCall>
</query>
</iq>

<iq type='set'     to='rpc@jabbim.cz/service'     id='rpc0000'>
<query xmlns='jabber:iq:rpc'>
<methodCall>
<methodName>isVIPMany</methodName>
<params><param><value>
<array><data>
<value><string>gorila@dione.zcu.cz</string></value>
<value><string>gorila@jabber.cz</string></value>
</data></array>
</value></param></params>
</methodCall>
</query>
</iq>


*/

       liCount=0; 
       // walk all jid in file
__HHUNG        for (loJID = xmlnode_get_tag(loFile,"item"); loJID != NULL; loJID = xmlnode_get_nextsibling(loJID))
           {
           if (loJID->type!=NTYPE_TAG)
               continue;

__HHUNG            lcJID=xmlnode_get_attrib(loJID,"jid");
           if (lcJID!=NULL)
              {
              liCount++; 
              }
           }

       // generuj IsVIPMany pro maximln 100 JID

       // zapi si skupinu souboru a poet JID
__HHUNG        xmlnode_put_attrib((loGroup=xmlnode_insert_tag(jtin->tmpVIP,"file")),"type",xmlnode_get_attrib(loFile,"type"));
__HHUNG        xmlnode_put_attrib(loGroup,"count",smtp_itoa(p,liCount));

__HHUNG        for (loJID = xmlnode_get_tag(loFile,"item"); loJID != NULL; loJID = xmlnode_get_nextsibling(loJID))
           {
           if (loJID->type!=NTYPE_TAG)
               continue;

           lcJID=xmlnode_get_attrib(loJID,"jid");
           if (lcJID!=NULL)
              {
              // poli RPC
__HHUNG               loRPC=xmlnode_new_tag_pool(p,"iq");

__HHUNG               xmlnode_put_attrib(loRPC,"to",lcVIP);
__HHUNG               xmlnode_put_attrib(loRPC,"from",jtin->met);
__HHUNG               xmlnode_put_attrib(loRPC,"type","set");
__HHUNG               xmlnode_put_attrib(loRPC,"id",spools(p,"viprpc-",lcJID,p));

__HHUNG               xmlnode_put_attrib(loQuery=xmlnode_insert_tag(loRPC,"query"),"xmlns",NS_IQ_RPC);

__HHUNG               loMC=xmlnode_insert_tag(loQuery,"methodCall");
__HHUNG               xmlnode_insert_cdata(xmlnode_insert_tag(loMC,"methodName"),"isVIP",-1);
__HHUNG               loMC=xmlnode_insert_tag(loMC,"params");
__HHUNG               loMC=xmlnode_insert_tag(loMC,"param");
__HHUNG               loMC=xmlnode_insert_tag(loMC,"value");
__HHUNG               xmlnode_insert_cdata(xmlnode_insert_tag(loMC,"string"),lcJID,-1);

__HHUNG               deliver(dpacket_new(xmlnode_dup(loRPC)),jtin->i);
              }
           else
              {
__HHUNG               log_alert(SMTP_ZONE,"ROSTER - JID not define for item: %s.",xmlnode2str(xmlnode_dup_pool(p,loJID)));
              }
           }
       }

__HHUNG    pool_free(p);
__HHUNG    pthread_mutex_unlock(&vip_mutex);
   if ((jtin->iLogDebug&2)==2)
      log_notice(SMTP_ZONE,"VIP module - END");
   return;
   }




// create new thread for getting vip flag
result smtp_vip_daemon(void *arg)
   {
   pool p=pool_new();
   smtp_PoolsReg(30, p);

__HHUNG   smtp_tu par_o;

__HHUNG   par_o=pmalloco(p, sizeof(_smtp_tu));
__HHUNG   par_o->p=p;

__HHUNG   par_o->q=mtq_new(p);
__HHUNG   mtq_send(par_o->q, p, smtp_vip_mtq, (void *)par_o);
   return r_DONE;
   }

void vip_InitDaemon()
   {
   xmlnode cur;
   if ((cur=xmlnode_get_tag(jtin->config,"core/vip"))!=NULL)
      register_beat(j_atoi(xmlnode_get_attrib(cur,"interval"),1)*60 , smtp_vip_daemon, (void *)jtin);
   }
 
